<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('JPATH_BASE') or die;

require_once JPATH_ADMINISTRATOR . '/components/com_smartsub/helpers/smartsub.php';

JFormHelper::loadFieldClass('user');

class JFormFieldUserFilter extends JFormFieldUser
{
	public $type = 'UserFilter';

	protected function getInput()
	{
		$input = parent::getInput();
		
		// make "user" field type compatible with search tools filters - "clear" button
		// must reset user filter. Add handler to filters clear button
		JFactory::getDocument()->addScriptDeclaration('
			jQuery(document).ready(function($) {
				// we rely on default filter clear button class
				var button_clear = $(".js-stools-btn-clear");
				if(button_clear.length) {
					// button found - add handler to empty user_id value
					button_clear.click(function() {
						$("#filter_user_id_id").val("");
					});
					// move recently added event to the head of click events queue
					var eventList = $._data(button_clear[0], "events");
					eventList.click.unshift(eventList.click.pop());
					// correct style, so that user filter is aligned with the rest of filters
					// *** this is a cheap fix
					$("#filter_user_id").closest("div.input-append").css("margin-bottom", 0);
				} else {
					// button not found - hide filter to make it inoffensive (degrade)
					$("#filter_user_id").closest("div.input-append").hide();
					$("#filter_user_id_id").val("");
				}
			});
		');
		return $input;
	}
}
