<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . '/helpers/html');

JHtml::_('behavior.formvalidation');

JHtml::_('smartsubbehavior.customvalidation');
JHtml::_('smartsubbehavior.customreplace');

JHtml::_('formbehavior.chosen', 'select');

$params = $this->state->get('params');
$currency = $params->get('default_currency', 'EUR');

?>
<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'account.cancel' || document.formvalidator.isValid(document.id('account-form'))) {
			<?php echo $this->form->getField('description')->save(); ?>
			Joomla.submitform(task, document.getElementById('account-form'));
		}
	};
</script>

<form action="<?php echo JRoute::_('index.php?option=com_smartsub&view=account&layout=edit&id=' . (int) $this->item->id); ?>" method="post" name="adminForm" id="account-form" class="form-validate">

	<?php echo JLayoutHelper::render('joomla.edit.title_alias', $this); ?>

	<div class="form-horizontal">
		<?php echo JHtml::_('bootstrap.startTabSet', 'myTab', array('active' => 'details')); ?>

		<?php echo JHtml::_('bootstrap.addTab', 'myTab', 'details', empty($this->item->id) ? JText::_('COM_SMARTSUB_NEW_ACCOUNT', true) : JText::_('COM_SMARTSUB_EDIT_ACCOUNT', true)); ?>
		<div class="row-fluid">
			<div class="span9">
				<div class="form-horizontal">
					<div class="control-group">
						<div class="control-label"><?php echo $this->form->getLabel('amount'); ?></div>
						<div class="controls"><?php echo $this->form->getInput('amount'); ?> <?php echo $this->form->getInput('currencyID'); ?></div>	
					</div>
					<?php echo $this->form->renderField('group_id'); ?>
					<div class="control-group">
						<div class="control-label"><?php echo $this->form->getLabel('valid_period'); ?></div>
						<div class="controls"><?php echo $this->form->getInput('valid_period'); ?> <?php echo $this->form->getInput('valid_period_unit'); ?></div>	
					</div>
				</div>
				<div class="form-vertical">
					<?php echo $this->form->renderField('description'); ?>
				</div>
			</div>
			<div class="span3">
				<?php echo JLayoutHelper::render('joomla.edit.global', $this); ?>
				<div class="form-vertical">
					<?php echo $this->form->renderField('is_default'); ?>
				</div>
			</div>
		</div>
		<?php echo JHtml::_('bootstrap.endTab'); ?>

		<?php echo JLayoutHelper::render('joomla.edit.params', $this); ?>

		<?php echo JHtml::_('bootstrap.endTabSet'); ?>

	</div>

	<input type="hidden" name="task" value="" />
	<?php echo JHtml::_('form.token'); ?>
</form>
