<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('_JEXEC') or die;

class SmartsubViewAccounts extends JViewLegacy
{
	protected $items;

	protected $pagination;

	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');

		SmartsubHelper::addSubmenu('accounts');

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since   1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT . '/helpers/smartsub.php';

		$state	= $this->get('State');
		$canDo	= JHelperContent::getActions('com_smartsub');
		$user	= JFactory::getUser();

		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');

		JToolbarHelper::title(JText::_('COM_SMARTSUB_MANAGER_ACCOUNTS'), 'account smartsub');
		if ($canDo->get('core.create'))
		{
			JToolbarHelper::addNew('account.add');
		}
		if ($canDo->get('core.edit'))
		{
			JToolbarHelper::editList('account.edit');
		}
		if ($canDo->get('core.edit.state'))
		{

			JToolbarHelper::publish('accounts.publish', 'JTOOLBAR_PUBLISH', true);
			JToolbarHelper::unpublish('accounts.unpublish', 'JTOOLBAR_UNPUBLISH', true);

			JToolbarHelper::archiveList('accounts.archive');
			JToolbarHelper::checkin('accounts.checkin');
		}
		if ($state->get('filter.state') == -2 && $canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList('', 'accounts.delete', 'JTOOLBAR_EMPTY_TRASH');
		}
		elseif ($canDo->get('core.edit.state'))
		{
			JToolbarHelper::trash('accounts.trash');
		}
		if ($user->authorise('core.admin', 'com_smartsub'))
		{
			JToolbarHelper::preferences('com_smartsub');
		}

		//JToolbarHelper::help('JHELP_COMPONENTS_SMARTSUB_ACCOUNTS');

		JHtmlSidebar::setAction('index.php?option=com_smartsub&view=accounts');

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true)
		);
	}

	protected function getSortFields()
	{
		return array(
			'a.ordering' => JText::_('JGRID_HEADING_ORDERING'),
			'a.state' => JText::_('JSTATUS'),
			'a.title' => JText::_('JGLOBAL_TITLE'),
			'a.amount' => JText::_('COM_SMARTSUB_ACCOUNTS_SORT_AMOUNT'),
			'a.currencyID' => JText::_('COM_SMARTSUB_ACCOUNTS_SORT_CURRENCYID'),
			'a.id' => JText::_('JGRID_HEADING_ID')
		);
	}
}
