<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('_JEXEC') or die;

class SmartsubViewPayment extends JViewLegacy
{
	protected $state;

	protected $item;

	protected $form;

	public function display($tpl = null)
	{
		$this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		$this->addToolbar();
		
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		JFactory::getApplication()->input->set('hidemainmenu', true);

		$user		= JFactory::getUser();
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));

		// Since we don't track these assets at the item level, use the category id.
		$canDo		= JHelperContent::getActions('com_smartsub');

		JToolbarHelper::title(JText::_('COM_SMARTSUB_MANAGER_PAYMENT'), 'payment smartsub');

		// If not checked out, can save the item.
		if (!$checkedOut && $canDo->get('core.edit'))
		{
			JToolbarHelper::apply('payment.apply');
			JToolbarHelper::save('payment.save');
		}
		JToolbarHelper::cancel('payment.cancel', 'JTOOLBAR_CLOSE');

		//JToolbarHelper::divider();
		//JToolbarHelper::help('JHELP_COMPONENTS_SMARTSUB_ACCOUNT_EDIT');
	}
}
