<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('_JEXEC') or die;

class SmartsubViewPayments extends JViewLegacy
{
	protected $items;

	protected $pagination;

	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->filterForm	= $this->get('FilterForm');
		$this->activeFilters = $this->get('ActiveFilters');

		SmartsubHelper::addSubmenu('payments');

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		// Include the component HTML helpers.
		JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');
		
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since   1.6
	 */
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT . '/helpers/smartsub.php';

		$state	= $this->get('State');
		$canDo	= JHelperContent::getActions('com_smartsub');
		$user	= JFactory::getUser();

		// Get the toolbar object instance
		$bar = JToolBar::getInstance('toolbar');

		JToolbarHelper::title(JText::_('COM_SMARTSUB_MANAGER_PAYMENTS'), 'account smartsub');
		if ($canDo->get('core.edit'))
		{
			JToolbarHelper::editList('payment.edit');
		}
		if ($canDo->get('core.edit.state'))
		{
			JToolbarHelper::custom('payments.setpaid', 'publish.png', 'publish_f2.png', 'COM_SMARTSUB_TOOLBAR_SETPAID', true);
			JToolbarHelper::custom('payments.setpending', 'unpublish.png', 'unpublish_f2.png', 'COM_SMARTSUB_TOOLBAR_SETPENDING', true);
			JToolbarHelper::checkin('payments.checkin');
		}
		if ($canDo->get('core.delete'))
		{
			JToolbarHelper::deleteList('', 'payments.delete');
		}
		
		if ($user->authorise('core.admin'))
		{
			JToolbarHelper::custom('payments.initusers', 'refresh.png', 'refresh_f2.png', 'COM_SMARTSUB_TOOLBAR_INITUSERS', false);
		}
		
		if ($user->authorise('core.admin', 'com_smartsub'))
		{
			JToolbarHelper::preferences('com_smartsub');
		}

		//JToolbarHelper::help('JHELP_COMPONENTS_SMARTSUB_ACCOUNTS');

		JHtmlSidebar::setAction('index.php?option=com_smartsub&view=payments');
	}
}
