<?php
/**
 * @package Smartsub (Smart Subscriptions) for Joomla 3
 * @version 1.2.2
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('_JEXEC') or die;

class SmartsubControllerFree extends JControllerLegacy
{
	public function profile()
	{
		// Check for request forgeries.
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$task = $this->getTask();
		
		$user = JFactory::getUser();
		
		if($user->get('guest') == 1)
		{
			$this->setRedirect(JUri::base());
			return;
		}
		
		$userId	= (int) $user->get('id');
		JFactory::getLanguage()->load('com_users');

		$app	= JFactory::getApplication();
		
		// Get the user data.
		$requestData = $this->input->post->get('jform', array(), 'array');
		
		JModelLegacy::addIncludePath(JPATH_ROOT . '/components/com_users/models', 'UsersModel');
		
		$model	= JModelLegacy::getInstance('Profile', 'UsersModel', array());
		// Force the ID to this user.
		$requestData['id'] = $userId;
		
		// Validate the posted data.
		JForm::addFormPath(JPATH_ROOT . '/components/com_users/models/forms');
		$form	= $model->getForm();

		if(!$form)
		{
			JError::raiseError(500, $model->getError());
			return false;
		}
		
		$data	= $model->validate($form, $requestData);

		// Check for validation errors.
		if ($data === false)
		{
			// Get the validation messages.
			$errors	= $model->getErrors();

			// Push up to three validation messages out to the user.
			for ($i = 0, $n = count($errors); $i < $n && $i < 3; $i++)
			{
				if ($errors[$i] instanceof Exception)
				{
					$app->enqueueMessage($errors[$i]->getMessage(), 'warning');
				}
				else
				{
					$app->enqueueMessage($errors[$i], 'warning');
				}
			}

			// Save the data in the session.
			
			$app->setUserState('com_users.edit.profile.data', $requestData);
			$userId = (int) $app->getUserState('com_users.edit.profile.id');
			// Redirect back to the registration screen.
			$this->setRedirect(JRoute::_('index.php?option=com_users&view=profile&layout=edit&user_id=' . $userId, false));

			return false;
		}

		// Attempt to save the data.
		$return	= $model->save($data);

		// Check for errors.
		if($return === false)
		{
			// Save the data in the session.
			
			$app->setUserState('com_users.edit.profile.data', $data);
			$userId = (int) $app->getUserState('com_users.edit.profile.id');
			// Redirect back to the edit screen.
			$this->setMessage(JText::sprintf('COM_USERS_PROFILE_SAVE_FAILED', $model->getError()), 'warning');
			$this->setRedirect(JRoute::_('index.php?option=com_users&view=profile&layout=edit&user_id=' . $userId, false));
			
			return false;
		}

		$app->setUserState('com_users.edit.profile.data', null);
		
		$this->setRedirect(JRoute::_('index.php?option=com_users&view=profile', false), JText::_('COM_SMARTSUB_PAYMENT_TRANSACTION_SUCCESS'), 'info');
		return true;
	}
}
