<?php
/*-------------------------------------------------------------------------
# mod_fancy_tagcloud - Fancy TagCloud
# -------------------------------------------------------------------------
# @ author    Jeno Kovacs
# @ copyright Copyright (C) 2014 Offlajn.com  All Rights Reserved.
# @ license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# @ website   http://www.offlajn.com
-------------------------------------------------------------------------*/
$revision = '1.015';
?><?php
// Report all PHP errors (see changelog)
defined('_JEXEC') or die('Restricted access');

global $ImageHelper, $bgHelper; 


require_once(dirname(__FILE__).DS.'helpers'.DS.'functions.php');

$module->navClassPrefix = 'off-scr-';
$module->instanceid = 'offlajn-tagcloud-'.$module->id.'-1';
$module->containerinstanceid = $module->instanceid.'-container';
$document = JFactory::getDocument();

if(version_compare(JVERSION,'1.6.0','ge')) {
  if ($params->get('moduleclass_sfx', '') != @$params->get('otherTab')->moduleclass_sfx) {
    $params->set('moduleclass_sfx', $params->get('otherTab')->moduleclass_sfx);
    $db =& JFactory::getDBO();
    $db->setQuery('UPDATE #__modules SET params=\''.addslashes($params->toString()).'\' WHERE id='.$module->id);
    $db->query();
  }
  $params->loadArray(o_flat_array($params->toArray()));
}

if(defined('DEMO')) {
  $_SESSION['module_id'] = $module->id;
  if(!isset($_SESSION[$module->module.'a'][$module->id])) {
    $_SESSION[$module->module.'a'] = array();
    $a = $params->toArray();
    $a['params'] = $a;
    $params->loadArray($a);
    $_SESSION[$module->module."_orig"] = $params->toString();
    $_SESSION[$module->module.'a'][$module->id] = true;
    $_SESSION[$module->module."_params"] = $params->toString();
    header('LOCATION: '.$_SERVER['REQUEST_URI']);
  }
  if(isset($_SESSION[$module->module."_params"])){
    $params = new JRegistry();
    $params->loadString($_SESSION[$module->module."_params"]);
  }
  $a = $params->toArray();
  $thms = array();
  $themedir = __DIR__.'/themes';
  foreach (scandir($themedir) as $k=>$v) {
  	if ($k > 1 && is_dir("$themedir/$v")) $thms[] = $v;
  }
  $theme = isset($_POST['theme'])? $_POST['theme'] : $params->get('theme', 'simple');
  $document->addScriptDeclaration("dojo.addOnLoad(function(){window.theme = new Themechanger('$theme', ".json_encode($thms).");});");
  $params->loadArray(o_flat_array($a['params']));
  $themesdir = JPATH_SITE.'/modules/'.$module->module.'/themes/';
  $xmlFile = $themesdir.$theme.'/theme.xml';

  $xml = new SimpleXMLElement(file_get_contents($xmlFile));
  $skins = $xml->params[0]->param[0];
  $sks = array();
  foreach($skins->children() AS $skin){
    $sks[] = $skin->getName();
  }
  $document->addScriptDeclaration('dojo.addOnLoad(function(){window.skin = new Skinchanger({theme: "'.$theme.'",skins: '.json_encode($sks).'});});');

  if (isset($_POST['theme'])) $_REQUEST['skin'] = $sks[0];
  if (isset($_REQUEST['skin']) && $skins->{$_REQUEST['skin']}){
    $skin = $skins->{$_REQUEST['skin']}[0];
    $p = $params->toObject();
    foreach($skin AS $s){
      $name = $s->getName();
      $value = (string)$s;
      $params->set($name, $value);
      $p->{$name} = $p->moduleparametersTab->theme->{$name} =
        $p->params->{$name} = $p->params->moduleparametersTab->theme->{$name} = $value;
    }
    if (isset($_POST['theme'])) {
      $params->set('theme', $_POST['theme']);
      $p->theme = $p->moduleparametersTab->theme->theme =
        $p->params->theme = $p->params->moduleparametersTab->theme->theme = $_POST['theme'];
    }
    $_SESSION[$module->module."_params"] = json_encode($p);
  }
}

$type = preg_replace("/[^A-Za-z0-9]/", '', $params->get('menutype'));
if($type == '' or !file_exists(dirname(__FILE__).DS.'types'.DS.$type.DS.'tags.php')){
  echo JText::_('TagCloud type not exists!');
  return;
}

require_once(dirname(__FILE__).DS.'types'.DS.$type.DS.'tags.php');

$class = 'Offlajn'.ucfirst($type).'Tags';
if(!class_exists($class)) return;
$slider = new $class($module, $params);
$itemsCount = $slider->getItems();


/*
Loading the template file for the theme
*/
$templateDir = dirname(__FILE__).DS.'template'.DS;

$theme = $params->get('theme', 'default');
$tmpl = $templateDir.$theme.'.php';

if(!file_exists($tmpl)){
  $tmpl = $templateDir.'default.php';
  if(!file_exists($tmpl)){
    echo JText::_('Template file missing for Offlajn TagCloud. Please reinstall the module.');
    return;
  }
}

$containerTmpl = $templateDir.$theme.'.php';


if(!file_exists($containerTmpl)){
  $containerTmpl = $templateDir.'default-cont.php';
  if(!file_exists($containerTmpl)){
    echo JText::_('Template file missing for Offlajn TagCloud. Please reinstall the module.');
    return;
  }
}

include($containerTmpl);

require_once(dirname(__FILE__).DS.'classes'.DS.'cache.class.php');
$cache = new OfflajnMenuThemeCache('simple', $module, $params);    

$root = JURI::root(true);
if ($root != '/') $root.= '/';

if (version_compare(JVERSION, '3.0.0', 'l')) {
  if ($params->get('jquery', 1)) {
    $document->addScript('https://ajax.googleapis.com/ajax/libs/jquery/1.8/jquery.min.js');
    $document->addScript($root.'media/offlajn/jquery.noconflict.js');
  }
} else JHtml::_('jquery.framework');

/*
Build the CSS
*/ 
$cache->addCss(dirname(__FILE__) .DS. 'themes' .DS. 'clear.css.php');
$cache->addCss(dirname(__FILE__) .DS. 'themes' .DS. $theme .DS. 'theme.css.php');

$cache->assetsAdded();

/*
Set up enviroment variables for the cache generation
*/
$module->url = JUri::root(true).'/modules/'.$module->module.'/';
$cache->addCssEnvVars('module', $module);

$ImageHelper = new OfflajnImageHelper($cache->cachePath, $cache->cacheUrl);
$bgHelper = new OfflajnBgHelper($cache->cachePath, $cache->cacheUrl);

/*
Add cached contents to the document
*/
$cacheFiles = $cache->generateCache();

  $document->addStyleSheet($cacheFiles[0]);
  $document->addScript($module->url."/js/jquery.awesomeCloud-0.2.min.js");
  $font = OfflajnValueParser::parse($params->get('googlefont'));
  $color = explode("-", $params->get('gradient'));
  $grid = $params->get('grid', '5');
  $factor = ( (float)$params->get('factor', '0.1') > 0 && (float)$params->get('factor', '0.1') < 1) ? (float)$params->get('factor', '0.1') : '0'; 
 
 $document->addScriptDeclaration('
  ;(window.jq183||jQuery)(document).ready(function($) {
    var cont = "'.$module->instanceid.'-container-inner";
  	$("." + cont).awesomeCloud({
  		"size" : {
  			"grid" : '.$grid.',
        "factor" : '.$factor.'
  		},
      "color": {
        background: "transparent",
        "start" : "#'.$color[1].'",  
        "end" : "#'.$color[2].'" 
      },
  		"options" : {
  			"rotationRatio" : 0.35,
  			"sort" : "random"
  		},
  		"font" : "\''.$font[0].'\', sans-serif",
  		"shape" : "square"
  	});
  });
 ');

?>