/**
 * @package plg_smartsub_offline (Offline payment plugin for Smart Subscriptions) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
function pr_offline_show_data(e) {
	
	var $this = jQuery(e);
	var form = $this.closest("form");
	
	// allow other handlers to run
	window.setTimeout(function() {
		form.submit();
	}, 500);
	return false;
}

(function ($){
	pr_offline_account_data = {
		options : {
			modal_id : 'pr-offline-modal',
			concept_span : 'pr-offline-info-concept',
			amount_span : 'pr-offline-info-amount',
			username_field_id : 'jform_username'
		},
		init : function(options) {
			this.options = $.extend(this.options, options);
		},
		
		showModal : function(button) {
			var $this = $(button);
			var form = $this.closest("form");
			
			// if the form is not valid, do not continue
			if(document.formvalidator && !document.formvalidator.isValid(form)) {
				return;
			}
			
			// show payment info modal
			$("#" + this.options.modal_id).modal('show');
			
			// inject username as concept
			var account_id = $("#jform_smartsub_account").val();
			var transactionID = this.options.transactionID_pattern
				.replace('%s', $("#" + this.options.username_field_id).val().toUpperCase())
				.replace('%03d', ("0000" + account_id).slice(-3));
			$("#" + this.options.concept_span).text(transactionID);
			
			// inject amount text (was formatted on server)
			var selected_account = $(".action-account[data-account-id='" + account_id + "']");
			if(selected_account.length == 0) {
				// compact view - find selected option from the dropdown
				selected_account = $(".action-account option:selected");
			}
			if(selected_account.length > 0) {
				$("#" + this.options.amount_span).text(selected_account.attr("data-amount-text") + ' ' + selected_account.attr("data-currency-id"));
			}
		},
		
		submit : function(button) {
			var $this = $(button);
			var form = $this.closest("form");
			
			// if the form is not valid, do not continue
			if(document.formvalidator && !document.formvalidator.isValid(form)) {
				return;
			}
			
			// allow other handlers to run
			window.setTimeout(function() {
				form.submit();
			}, 500);
		}
	};
})(jQuery);
