<?php
/**
 * @package plg_user_smartsub (Smart Subscriptions User Profile Plugin) for Joomla 3
 * @version 1.0
 * @author Alex Polonski
 * @copyright (C)2014 - Alex Polonski
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/
defined('JPATH_PLATFORM') or die;


class JFormFieldCancelAccount extends JFormField
{
	protected $type = 'CancelAccount';
	
	protected function getInput()
	{
		JFactory::getDocument()->addScriptDeclaration('
			jQuery(document).ready(function($) {
				$("#pr-cancelaccount-btn").click(function() {
					$("#jform_smartsub_account").val("");
					$(this)
						.text("' . JText::_('PLG_USER_SMARTSUB_ACCOUNT_CANCELLED') . '")
						.removeClass("btn-danger");
				});
				var account = $("#jform_smartsub_account").val();
				if(account > 0) {
					$("#pr-cancelaccount-btn").text("' . JText::_('PLG_USER_SMARTSUB_CANCEL_ACCOUNT') . '");
				} else {
					$("#pr-cancelaccount-btn").text("' . JText::_('PLG_USER_SMARTSUB_ACCOUNT_CANCELLED') . '").removeClass("btn-danger");
				}
			});
		');
		return '<button type="button" id="pr-cancelaccount-btn" class="btn btn-danger">' . JText::_('PLG_USER_SMARTSUB_CANCEL_ACCOUNT') . '</button>';
	}
}
